/* Function prototypes for ANSI environment  --  GNU-C usually  */
/*
#
#  Copyright 1990-1993   Matti.Aarnio @ FUNET.FI
#  This software is free under similar rules as BSD copyrights.
#  (Definitely this is NOT Public Domain.  "Just" FREELY AVAILABLE.
#   Don't clain you did this..)
#  You can use this, but you shall not held us liable for anything.
#  You must not use our name in marketing, in case you decide to
#  use this.  We do appreciate bug-reports  -> mailserver-owner@nic.funet.fi
#  for improving this piece of software.
*/

#ifndef	__
# ifdef __STDC__
#  define __(x) x
# else
#  define __(x) ()
# endif
#endif

#if 0

extern int	strcmp __(( const char *s1, const char *s2 ));
extern int	strcasecmp __(( const char *s1, const char *s2 ));
extern int	strncmp __(( const char *s1, const char *s2, const int len ));
extern int	strncasecmp __(( const char *s1, const char *s2, const int len ));
extern int	strlen __(( const char *str ));
extern char *	strcpy __(( char *s1, const char *s2 ));
extern char *	strncpy __(( char *s1, const char *s2, const int size ));
extern char *	strcat __(( char *s1, const char *s2 ));
extern void *	memset __(( void *ptr, const int setval, const int setsize ));
extern void *	memcpy __(( void *s1, const void *s2, size_t size ));


extern int	fgetc __(( FILE *stream ));
extern int	fputc __(( const char c, FILE *stream ));
extern char *	fgets __(( char *buf, int bufsize, FILE *stream ));
extern int	fputs __(( const void *str, FILE *stream ));
extern int	fread __(( void *buf, const int size, const int count, FILE *stream ));
extern int	fwrite __(( const void *buf, const int size, const int count, FILE *stream ));
extern int	_flsbuf __(( FILE *stream, const int chr ));
extern int	_filbuf __(( FILE *stream ));

extern int	rewind __(( FILE *stream ));
extern int	fseek __(( FILE *stream, const long offset, const int ptrname ));
extern int	flock __(( const int fd, const int operation ));
extern int	ftruncate __(( const int fd, const int length ));
extern int	unlink __(( const char *filename ));

extern int	printf __(( ));
extern int	fprintf __(( ));
extern int	sscanf __(( ));

extern int /*fd*/ mkstemp __(( char *template ));
extern FILE *	fopen __(( const char *name, const char *mode ));
extern int	fclose __(( FILE *stream ));
extern FILE *	popen __(( const char *name, const char *mode ));
extern int	pclose __(( FILE *stream ));
extern void	setlinebuf __(( FILE *stream ));
extern void	setbuffer __(( FILE *stream, void *buffer, const int size ));
extern int	setbuf __(( FILE *stream, void *buffer ));
extern int	fflush __(( FILE *stream ));

extern int	chown  __(( const char *path, const int owner, const int group ));
extern int	fchown __(( const int fd, const int owner, const int group ));
#ifndef	fileno
extern int	fileno __(( const FILE *p ));
#endif

extern int	dup __(( const int fd ));
extern int	dup2 __(( const int fd1, const int fd2 ));


extern void	free __(( void *memptr ));
extern char *	malloc __(( const int size ));
extern char *	realloc __(( void *ptr, const int newsize ));

extern int	fork __(( void ));
extern int	execl __(( const char *path, const char *argv0, ... ));
extern int	execv __(( const char *path, const char *argv[] ));
extern int	execvp __(( const char *path, const char *argv[] ));
extern void	exit __(( const int rc ));
extern void	_exit __(( const int rc ));
extern void	abort __(( const int rc ));

extern int	chdir __(( const char *dirpath ));
extern char *	getwd __(( char path[MAXPATHLEN] ));

extern int	gettimeofday();
extern int	getrusage();

extern int	qsort __(( void *base, const int nel, const int width, int (*compar)(const void *a, const void *b) ));

#ifndef	islower
extern int	islower __(( const int ch ));
#endif
#ifndef	isupper
extern int	isupper __(( const int ch ));
#endif
#ifndef	tolower
extern int	tolower __(( const int ch ));
#endif
#ifndef	toupper
extern int	toupper __(( const int ch ));
#endif

extern char *	getenv __(( const char *varname ));
extern int	putenv __(( const char *envvar ));

#endif

/* --- Things from our own library --- */

     /* sigstring.c */
extern char *	strsignal __(( const int signalnro ));
extern char *	strerror __(( const int errno ));
extern char *basename __(( const char *filename ));

     /* utils.c */
extern void *xrealloc __(( void *ptr, unsigned size ));
extern char *xsalloc __(( char *str ));
extern void *xcalloc __(( unsigned size ));
extern char *upperstr __(( char *str ));
extern char *lowerstr __(( char *str ));
extern char *pick_nextarg __(( char *argstr ));
extern int  revdomaincmp __(( char *a, char *b ));	/* For qsort() */

     /* popen.c */
extern FILE *rootcmdpopen __((char *root, char *defdir, int uid, int gid, char *cmd, char *args, char *opentype, pid_t *pidp));
extern void rootcmdpclose __((FILE *fd));

    /* suspectaddr.c */
extern int is_suspect_addr __((char *mailpath));

     /* fastcd.c */
extern int   OpenFastCdDBM __(( int flags /* O_RDONLY etc.. */ ));
extern char *FindFastCdDir __(( char *dirname ));

     /* glob.c */
extern char **glob __(( const char *str ));
extern char *globerr;
extern char *home;
extern char *globchars;
extern int  letter __(( const char c ));
extern int  digit  __(( const char c ));
extern int  any    __(( const int c, const char *s ));
extern int  blklen __(( char const **av ));
extern char **blkcpy __(( char **oav, char const *bv ));
extern void  blkfree __(( const char **av0 ));
extern char **copyblk __(( const char **v ));
extern int   gethdir __(( char *home ));
